=== modified file '__init__.py'
--- __init__.py	2006-10-08 20:51:52 +0000
+++ __init__.py	2006-10-25 09:00:02 +0000
@@ -215,7 +215,7 @@
 
         (wt, path) = WorkingTree.open_containing(filename)
 
-        dialog = CommitDialog(wt, path)
+        dialog = CommitDialog(wt, path, standalone=True)
         dialog.display()
         gtk.main()
 

=== modified file 'olive/commit.py'
--- olive/commit.py	2006-10-25 08:34:09 +0000
+++ olive/commit.py	2006-10-25 09:00:02 +0000
@@ -33,13 +33,20 @@
 
 class CommitDialog:
     """ Display Commit dialog and perform the needed actions. """
-    def __init__(self, wt, wtpath):
-        """ Initialize the Commit dialog. """
+    def __init__(self, wt, wtpath, standalone=False):
+        """ Initialize the Commit dialog.
+        @param  wt:         bzr working tree object
+        @param  wtpath:     path to working tree root
+        @param  standalone: when used in gcommit command as standalone window
+                            this argument should be True
+        """
         self.glade = gtk.glade.XML(GLADEFILENAME, 'window_commit', 'olive-gtk')
         
         self.wt = wt
         self.wtpath = wtpath
 
+        self.standalone = standalone
+
         # Get some important widgets
         self.window = self.glade.get_widget('window_commit')
         self.checkbutton_local = self.glade.get_widget('checkbutton_commit_local')
@@ -65,6 +72,9 @@
         # Dictionary for signal_autoconnect
         dic = { "on_button_commit_commit_clicked": self.commit,
                 "on_button_commit_cancel_clicked": self.close }
+
+        if self.standalone:
+            dic["on_button_commit_cancel_clicked"] = self.quit
         
         # Connect the signals to the handlers
         self.glade.signal_autoconnect(dic)
@@ -271,8 +281,15 @@
         except Exception, msg:
             error_dialog(_('Unknown error'), str(msg))
             return
-        
-        self.close()
+
+        if not self.standalone:
+            self.close()
+        else:
+            self.quit()
         
     def close(self, widget=None):
         self.window.destroy()
+
+    def quit(self, widget=None):
+        self.close(widget)
+        gtk.main_quit()

